Overview | Modules | Class Hierarchy | Classes | Members

# tlp::GlMainView Class Reference

`#include <GlMainView.h>`

Inherits tlp::AbstractView.

Inherited by tlp::NodeLinkDiagramComponent.

Inheritance diagram for tlp::GlMainView:

[legend]
Collaboration diagram for tlp::GlMainView:

[legend]
List of all members.

## Detailed Description

Provide an abstract view with OpenGl rendering.

This class provide an abstract view with OpenGl rendering and overview To do this rendering GlMainView class is use

## Public Slots

- virtual void draw ()
- virtual void refresh ()
- virtual void hideOverview (bool)
- virtual void showDialog (QAction *action)

## Public Member Functions

- GlMainView ()
- virtual ~GlMainView ()
- virtual QWidget * construct (QWidget *parent)
- Graph * getGraph ()
- GlMainWidget * getGlMainWidget ()
- virtual void createPicture (const std::string &pictureName, int width=0, int height=0)
- virtual void buildContextMenu (QObject *object, QMouseEvent *event, QMenu *contextMenu)
- GWOverviewWidget * getOverviewWidget ()
- QAction * getOverviewAction ()

## Protected Member Functions

- virtual void addLayer (tlp::GlScene *, const std::string &, tlp::GlLayer *)
- virtual void modifyLayer (tlp::GlScene *, const std::string &, tlp::GlLayer *)

## Protected Attributes

- GlMainWidget * mainWidget
- QDockWidget * overviewDock
- GWOverviewWidget * overviewWidget
- QFrame * overviewFrame
- QMenu * dialogMenu
- QAction * overviewAction

## Constructor & Destructor Documentation

tlp::GlMainView::GlMainView | ( |  | ) |

| Basic contructor

virtual tlp::GlMainView::~GlMainView | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void tlp::GlMainView::addLayer | ( | tlp::GlScene * | ,
|  | const std::string & | ,
|  | tlp::GlLayer * |
| ) | `[inline, protected, virtual]`

| function call by GlSceneObserver Reimplemented in tlp::NodeLinkDiagramComponent.

virtual void tlp::GlMainView::buildContextMenu | ( | QObject * | object,
|  | QMouseEvent * | event,
|  | QMenu * | contextMenu
| ) | `[virtual]`

| Build context menu for this view Reimplemented from tlp::AbstractView. Reimplemented in tlp::NodeLinkDiagramComponent.

virtual QWidget* tlp::GlMainView::construct | ( | QWidget * | parent | ) | `[virtual]`

Construct this view

Warning:
  If your view inherit of GlMainView you must extend construct function and in this new function call GlMainView::construct(QWidget *)

Reimplemented from tlp::AbstractView.

Reimplemented in tlp::NodeLinkDiagramComponent.

virtual void tlp::GlMainView::createPicture | ( | const std::string & | pictureName,
|  | int | width = `0`,
|  | int | height = `0`
| ) | `[virtual]`

| Take a snapshot of the view and put it in a picture Implements tlp::View.

virtual void tlp::GlMainView::draw | ( |  | ) | `[virtual, slot]`

| Draw the OpenGl widget Implements tlp::View. Reimplemented in tlp::NodeLinkDiagramComponent.

GlMainWidget* tlp::GlMainView::getGlMainWidget | ( |  | ) |

get GlMainWidget use by this view

Returns:
  the GlMainWidget use in this view

Graph* tlp::GlMainView::getGraph | ( |  | ) | `[virtual]`

get the graph use in this view

Returns:
  the graph use in this view

Implements tlp::View.

QAction* tlp::GlMainView::getOverviewAction | ( |  | ) | `[inline]`

| Return QAction of overview use in the context menu

GWOverviewWidget* tlp::GlMainView::getOverviewWidget | ( |  | ) | `[inline]`

| Return the overview widget use by this view

virtual void tlp::GlMainView::hideOverview | ( | bool |  | ) | `[virtual, slot]`

| Hide the overview

virtual void tlp::GlMainView::modifyLayer | ( | tlp::GlScene * | ,
|  | const std::string & | ,
|  | tlp::GlLayer * |
| ) | `[inline, protected, virtual]`

| function call by GlSceneObserver Reimplemented in tlp::NodeLinkDiagramComponent.

virtual void tlp::GlMainView::refresh | ( |  | ) | `[virtual, slot]`

| Refresh the OpenGl widget Implements tlp::View. Reimplemented in tlp::NodeLinkDiagramComponent.

virtual void tlp::GlMainView::showDialog | ( | QAction * | action | ) | `[virtual, slot]`

| This slot is call when a QAction in dialog sub menu of context menu is toggle Reimplemented in tlp::NodeLinkDiagramComponent.

## Member Data Documentation

QMenu* tlp::GlMainView::dialogMenu `[protected]`

GlMainWidget* tlp::GlMainView::mainWidget `[protected]`

QAction* tlp::GlMainView::overviewAction `[protected]`

QDockWidget* tlp::GlMainView::overviewDock `[protected]`

QFrame* tlp::GlMainView::overviewFrame `[protected]`

GWOverviewWidget* tlp::GlMainView::overviewWidget `[protected]`

Tulip Software by LaBRI Visualization Team 2001 - 2010